#pragma once

#include <iostream>
#include <string>
#include <vector>
#include <set>
#include <unordered_set>
#include "DataStructures.h"
#include <map>

class MeshLoader
{
protected:
	std::vector<Node> nodes; //!!! Плохой выбор контейнера - vector чем не подходит?
	std::vector<FiniteElement> elements; //!!! Плохой выбор контейнера - vector чем не подходит?
	std::vector<BoundaryFiniteElement> boundaryFEs; //!!! Плохой выбор контейнера - vector чем не подходит?

	std::unordered_set<Edge, std::hash<Edge>> edges;
public:
	virtual void LoadMesh(const std::string&) = 0;
	virtual ~MeshLoader() = default;

	// ,   STL- ,     
	const std::vector<Node>& getNodes();
	const std::vector<FiniteElement>& getFiniteElements();
	const std::vector<BoundaryFiniteElement>& getBoundaryFiniteElements();

	// ,     ID    
	std::vector<int> getElementsByID(int, int, int);

	// ,     ,    ID  
	std::vector<int> getElementsByEdge(int, int);

	// ,      ID 

	std::set<int> getNodesByBoundary(int);

	// ,      ID 
	std::set<int> getElementsByBoundary(int);

	// ,       ID 
	std::vector<int> getsboundaryFEsByBoundary(int);

	// ,         
	void insertCenterNode();

	// ,  , n -            n
	std::vector<std::set<int>> getNodeNeighbours();

	// ,    Node, FiniteElement  BoundaryFiniteElement  
	void Print_Data();

	// ,     ID  
	std::vector<int> getElementsByOneID(int);
	const std::vector<double>& findNodeRanges(int);
	std::vector<BoundaryFiniteElement> getTrianglesAndNodes(int);
	std::vector<Node>::iterator getNodeByID(int id);
	//double square(Node A, Node B, Node C);

};

std::ostream& operator<< (std::ostream&, const std::vector<int>&);